<?php
/**
 * @file
 * Define the rest_api_query class.
 */

class topsy_api_query extends rest_api_query {
  protected $host = 'otter.topsy.com';

  /**
   * Fetches ALL the items.
   *
   * ... despite the bugs in Topsy.com API's REST paging features.
   *
   * @see topsy_api_fetch_all()
   */
  function fetch_all($pages) {
    // Initialize to page one.
    $this->parameters['page'] = 1;
    $page = &$this->parameters['page'];

    // NONE of the API's paging variables are reliable with the experts API.
    for ($return = array(); empty($pages) || $page <= $pages; $page++) {

      // Execute the query.
      if ($this->execute()->success && is_array($this->result->response->list)) {

        // If there are no results, assume iteration is finished.
        if (empty($this->result->response->list)) {
          return $return;
        }

        // Merge in the result set.
        $return = array_merge($return, $this->result->response->list);
      }
      else {
        // This case indicates an error, such as 404 or 403 or an error in the
        // API and/or iteration logic.
        rve('error');
      }
    }

    return $return;
  }
}
